/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various ways cells can be referenced in a formula.
 * <p class="body">
 * Setting this on the [[Workbook.cellReferenceMode]] will also affect the row and column labels.
 * </p>
 */
export var CellReferenceMode = /*@__PURE__*/ (function (CellReferenceMode) {
    /**
     * Cells are referenced by first specifying characters representing the column and a one-based number
     * specifying the row (R54 or CA56). The dollar sign ($) can preface one or both identifiers to make them
     * absolute references ($A$7). Without the dollar sign, references still use absolute row and column addresses,
     * although shifting a formula to a new cell will perform a similar shift on all relative references.
     */
    CellReferenceMode[CellReferenceMode["A1"] = 1] = "A1";
    /**
     * Cells are referenced in the following format R<RowIndex>C<ColumnIndex> (R34C5 or R2C345).
     * These indices are one-based and represent absolute references. To create a relative reference in R1C1 mode, a relative
     * index must be placed inside square brackets following the R and/or C ( R[-1]C[5] or R9C[-3] ).  An R by itself
     * also represents a relative reference and is equivalent to R[0]. Similarly, C is equivalent to C[0], which means a
     * formula of =RC always references the cell which contains the formula.
     */
    CellReferenceMode[CellReferenceMode["R1C1"] = 0] = "R1C1";
    return CellReferenceMode;
})({});
/**
 * @hidden
 */
export let CellReferenceMode_$type = markEnum('CellReferenceMode', 'A1,1|R1C1,0');
