/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the axis position for a [[DataBarConditionalFormat]].
 */
export var DataBarAxisPosition = /*@__PURE__*/ (function (DataBarAxisPosition) {
    /**
     * Displays the axis at a variable position based on the ratio of the minimum
     * negative value to the maximum positive value in the associated range. Positive
     * values are displayed in a left-to-right direction; negative values are displayed
     * from right to left. When all values are positive, or all values are negative,
     * no axis is displayed.
     */
    DataBarAxisPosition[DataBarAxisPosition["Automatic"] = 0] = "Automatic";
    /**
     * Displays the axis at the midpoint of the cell, regardless of the set of values
     * in the associated range. Positive values are displayed in a left-to-right
     * direction; negative values are displayed from right to left.
     */
    DataBarAxisPosition[DataBarAxisPosition["Midpoint"] = 1] = "Midpoint";
    /**
     * No axis is displayed; positive and negative values are both displayed in
     * the left-to-right direction.
     */
    DataBarAxisPosition[DataBarAxisPosition["None"] = 2] = "None";
    return DataBarAxisPosition;
})({});
/**
 * @hidden
 */
export let DataBarAxisPosition_$type = markEnum('DataBarAxisPosition', 'Automatic,0|Midpoint,1|None,2');
