/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the ways to order the pages of multiple page worksheets.
 */
export var PageOrder = /*@__PURE__*/ (function (PageOrder) {
    /**
     * The first page to print is the top-left page. The next pages printed are below the first page.
     * When there are no more pages below, the page to the right of the top-left page is printed, then the pages
     * below it, and so on.
     */
    PageOrder[PageOrder["DownThenOver"] = 0] = "DownThenOver";
    /**
     * The first page to print is the top-left page. The next pages printed are right of the first page.
     * When there are no more pages to the right, the page below the top-left page is printed, then the pages
     * to the right of it, and so on.
     */
    PageOrder[PageOrder["OverThenDown"] = 1] = "OverThenDown";
    return PageOrder;
})({});
/**
 * @hidden
 */
export let PageOrder_$type = markEnum('PageOrder', 'DownThenOver,0|OverThenDown,1');
