/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various ways to print cell notes.
 */
export var PrintNotes = /*@__PURE__*/ (function (PrintNotes) {
    /**
     * Cell notes are not printed.
     */
    PrintNotes[PrintNotes["DontPrint"] = 0] = "DontPrint";
    /**
     * Cell notes are printed as they are shown on the worksheet. With this option, cell
     * notes will only appear in the printed worksheet if they are displayed on the worksheet
     * in Microsoft Excel. If the notes just show indicators in Excel, the indicators and notes
     * will not be printed.
     */
    PrintNotes[PrintNotes["PrintAsDisplayed"] = 1] = "PrintAsDisplayed";
    /**
     * Cell notes are printed on the last page, after the entire worksheet has printed.
     */
    PrintNotes[PrintNotes["PrintAtEndOfSheet"] = 2] = "PrintAtEndOfSheet";
    return PrintNotes;
})({});
/**
 * @hidden
 */
export let PrintNotes_$type = markEnum('PrintNotes', 'DontPrint,0|PrintAsDisplayed,1|PrintAtEndOfSheet,2');
