/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various way to combine a cell's value and format string to get its text.
 * @see [[WorksheetCell.getText]]
 * @see [[WorksheetCell.getText]]
 * @see [[WorksheetRow.getCellText]]
 * @see [[WorksheetRow.getCellText]]
 */
export var TextFormatMode = /*@__PURE__*/ (function (TextFormatMode) {
    /**
     * Format the cell text as it is displayed in the Microsoft Excel UI. This takes into account the cell width when
     * formatting the text.
     */
    TextFormatMode[TextFormatMode["AsDisplayed"] = 0] = "AsDisplayed";
    /**
     * Format the cell text as if it had unlimited space in the cell. However, this will not include padding characters
     * from the format string.
     */
    TextFormatMode[TextFormatMode["IgnoreCellWidth"] = 1] = "IgnoreCellWidth";
    return TextFormatMode;
})({});
/**
 * @hidden
 */
export let TextFormatMode_$type = markEnum('TextFormatMode', 'AsDisplayed,0|IgnoreCellWidth,1');
