/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which describe whether text is allowed to continue
 * vertically outside the bounds of the containing element.
 */
export var TextVerticalOverflow = /*@__PURE__*/ (function (TextVerticalOverflow) {
    /**
     * The text is clipped by the containing element.
     */
    TextVerticalOverflow[TextVerticalOverflow["Clip"] = 0] = "Clip";
    /**
     * The text is allowed to continue outside the bounds
     * of the containing element.
     */
    TextVerticalOverflow[TextVerticalOverflow["Overflow"] = 1] = "Overflow";
    /**
     * Overflowing text is truncated and an ellipsis is displayed.
     */
    TextVerticalOverflow[TextVerticalOverflow["Ellipsis"] = 2] = "Ellipsis";
    return TextVerticalOverflow;
})({});
/**
 * @hidden
 */
export let TextVerticalOverflow_$type = markEnum('TextVerticalOverflow', 'Clip,0|Overflow,1|Ellipsis,2');
