/*
*
* An XmlReader implementation for loading SGML (including HTML) converting it
* to well formed XML, by adding missing quotes, empty attribute values, ignoring
* duplicate attributes, case folding on tag names, adding missing closing tags
* based on SGML DTD information, and so on.
*
* Copyright (c) 2002 Microsoft Corporation. All rights reserved.
*
* Chris Lovett
*
*/
/* MD 2/27/13
 * This software is being re-used under the Microsoft Public License (MS-PL):
 * -----------------------------------------------------------------------------
 * This license governs use of the accompanying software. If you use the software, you accept this license. If you do not accept the
 * license, do not use the software.
 *
 * 1. Definitions
 * The terms "reproduce," "reproduction," "derivative works," and "distribution" have the same meaning here as under U.S. copyright law.
 * A "contribution" is the original software, or any additions or changes to the software. A "contributor" is any person that distributes
 * its contribution under this license. "Licensed patents" are a contributor's patent claims that read directly on its contribution.
 *
 * 2. Grant of Rights
 * (A) Copyright Grant- Subject to the terms of this license, including the license conditions and limitations in section 3, each
 *     contributor grants you a non-exclusive, worldwide, royalty-free copyright license to reproduce its contribution, prepare
 *     derivative works of its contribution, and distribute its contribution or any derivative works that you create.
 * (B) Patent Grant- Subject to the terms of this license, including the license conditions and limitations in section 3, each
 *     contributor grants you a non-exclusive, worldwide, royalty-free license under its licensed patents to make, have made, use,
 *     sell, offer for sale, import, and/or otherwise dispose of its contribution in the software or derivative works of the contribution
 *     in the software.
 *
 * 3. Conditions and Limitations
 * (A) No Trademark License- This license does not grant you rights to use any contributors' name, logo, or trademarks.
 * (B) If you bring a patent claim against any contributor over patents that you claim are infringed by the software, your patent license
 *     from such contributor to the software ends automatically.
 * (C) If you distribute any portion of the software, you must retain all copyright, patent, trademark, and attribution notices that are
 *     present in the software.
 * (D) If you distribute any portion of the software in source code form, you may do so only under this license by including a complete
 *     copy of this license with your distribution. If you distribute any portion of the software in compiled or object code form, you may
 *     only do so under a license that complies with this license.
 * (E) The software is licensed "as-is." You bear the risk of using it. The contributors give no express warranties, guarantees or conditions.
 *     You may have additional consumer rights under your local laws which this license cannot change. To the extent permitted under your
 *     local laws, the contributors exclude the implied warranties of merchantability, fitness for a particular purpose and non-infringement.
 * -----------------------------------------------------------------------------
 *
 * In addition, the public classes have been made internal and the namespace has been changed from Sgml to
 * Infragistics.Documents.Excel.Serialization.Excel2007.Sgml
 *
 * Also, I updated the code to work with Silverlight and WinRT.
 */
import { Decoder } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { intDivide } from "igniteui-angular-core";
import { u32BitwiseOr } from "igniteui-angular-core";
/**
 * @hidden
 */
export let Ucs4Decoder = /*@__PURE__*/ (() => {
    class Ucs4Decoder extends Decoder {
        constructor() {
            super(...arguments);
            this._g = new Array(4);
            this._j = 0;
        }
        a(a, b, c) {
            return intDivide((c + this._j), 4);
        }
        c(a, b, c, d, e) {
            let f = this._j;
            if (this._j > 0) {
                for (; f < 4; f++) {
                    this._g[f] = a[b];
                    b++;
                    c--;
                }
                f = 1;
                this._i(this._g, 0, 4, d, e);
                e++;
            }
            else {
                f = 0;
            }
            f = this._i(a, b, c, d, e) + f;
            let g = (this._j + c) % 4;
            c += b;
            b = c - g;
            this._j = 0;
            if (b >= 0) {
                for (; b < c; b++) {
                    this._g[this._j] = a[b];
                    this._j++;
                }
            }
            return f;
        }
        _h(a) {
            let b, c;
            b = (55232 + (a >>> 10));
            c = (u32BitwiseOr(56320, a & 1023));
            return String.fromCharCode(((c << 8) | b));
        }
    }
    Ucs4Decoder.$t = markType(Ucs4Decoder, 'Ucs4Decoder', Decoder.$);
    return Ucs4Decoder;
})();
