/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
export let UltraCalcFunctionEffect = /*@__PURE__*/ (() => {
    class UltraCalcFunctionEffect extends BuiltInFunctionBase {
        evaluate(a, b) {
            return CalcFunctionUtilities.j(a, false, (c, d) => {
                let e = truncate(d);
                let f = e;
                if (c <= 0 || f < 1) {
                    return new ExcelCalcValue(new ExcelCalcErrorValue(4));
                }
                let g = Math.pow(1 + c / f, f) - 1;
                return new ExcelCalcValue(g);
            });
        }
        get_maxArgs() {
            return 2;
        }
        get maxArgs() {
            return this.get_maxArgs();
        }
        get_minArgs() {
            return 2;
        }
        get minArgs() {
            return this.get_minArgs();
        }
        get_name() {
            return "effect";
        }
        get name() {
            return this.get_name();
        }
    }
    UltraCalcFunctionEffect.$t = markType(UltraCalcFunctionEffect, 'UltraCalcFunctionEffect', BuiltInFunctionBase.$);
    return UltraCalcFunctionEffect;
})();
