/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various areas which can have a format applied at the table column level.
 * @see [[WorksheetTableColumn.areaFormats]]
 */
export var WorksheetTableColumnArea = /*@__PURE__*/ (function (WorksheetTableColumnArea) {
    /**
     * The format is applied to the data area of the table column.
     */
    WorksheetTableColumnArea[WorksheetTableColumnArea["DataArea"] = 0] = "DataArea";
    /**
     * The format is applied to the header cell of the table column.
     */
    WorksheetTableColumnArea[WorksheetTableColumnArea["HeaderCell"] = 1] = "HeaderCell";
    /**
     * The format is applied to the total cell of the table column.
     */
    WorksheetTableColumnArea[WorksheetTableColumnArea["TotalCell"] = 2] = "TotalCell";
    return WorksheetTableColumnArea;
})({});
/**
 * @hidden
 */
export let WorksheetTableColumnArea_$type = markEnum('WorksheetTableColumnArea', 'DataArea,0|HeaderCell,1|TotalCell,2');
