/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, fromEnum, String_$type, markType } from "igniteui-angular-core";
import { Regex } from "igniteui-angular-core";
import { Uri } from "igniteui-angular-core";
import { UriUtilities } from "./UriUtilities";
import { Package } from "./Package";
import { Convert } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { StringBuilder } from "igniteui-angular-core";
import { DocCoreUtils } from "./DocCoreUtils";
import { stringStartsWith, stringEmpty, stringReplace, stringIsNullOrEmpty, stringEndsWith } from "igniteui-angular-core";
import { toUniversalTime, dateToStringFormat, toLocalTime } from "igniteui-angular-core";
import { dateNow } from "igniteui-angular-core";
/**
 * @hidden
 */
var PackageUtilities = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PackageUtilities, _super);
    function PackageUtilities() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PackageUtilities.j = function (a, b) {
        if (stringStartsWith(b, ".." + "/")) {
            return PackageUtilities.j(PackageUtilities.n(a), b.substr(3));
        }
        var c = a.length > 0 && a.charAt(a.length - 1) == "/";
        var d = b.length > 0 && b.charAt(0) == "/";
        if (d) {
            return b;
        }
        if (c != d) {
            return a + b;
        }
        if (c) {
            return a + b.substr(1);
        }
        return a + "/" + b;
    };
    PackageUtilities.ag = function (a, b) {
        var c = a.toString();
        var d = b.toString();
        return UriUtilities.b(PackageUtilities.j(c, d));
    };
    PackageUtilities.a = function (a, b) {
        return Package._d(a, b ? 3 : 2);
    };
    PackageUtilities.k = function (a) {
        var b = toUniversalTime(a);
        return dateToStringFormat(b, "s") + "Z";
    };
    PackageUtilities.m = function (a) {
        var b = PackageUtilities.n(a);
        var c = PackageUtilities.o(a);
        var d = PackageUtilities.j(b, "_rels");
        var e = c + ".rels";
        return PackageUtilities.j(d, e);
    };
    PackageUtilities.n = function (a) {
        var b = a.lastIndexOf("/");
        if (b < 0) {
            return a;
        }
        return a.substr(0, b);
    };
    PackageUtilities.ah = function (a) {
        return new Uri(1, PackageUtilities.n(a.toString()), 2);
    };
    PackageUtilities.o = function (a) {
        var b = a.lastIndexOf("/");
        if (b < 0) {
            return a;
        }
        return a.substr(b + 1);
    };
    PackageUtilities.e = function (a) {
        if (a == null || a.length != 3 || a.charAt(0) != '%') {
            PackageUtilities.al("The value passed to GetPercentEncodedValue was not expoected: " + a);
            return 0;
        }
        try {
            return Convert.toByte2(a.substr(1), 16);
        }
        catch (b) {
            PackageUtilities.al("The value passed to GetPercentEncodedValue was not expoected: " + a);
            return 0;
        }
    };
    PackageUtilities.ai = function (a, b) {
        return PackageUtilities.aj(a, b, "/");
    };
    PackageUtilities.aj = function (a, b, c) {
        var d = PackageUtilities.q(a.toString(), b.toString(), "/", false);
        return UriUtilities.b(d);
    };
    PackageUtilities.p = function (a, b) {
        return PackageUtilities.q(a, b, "/", false);
    };
    PackageUtilities.q = function (a, b, c, d) {
        var e_1, _a;
        var e = PackageUtilities.h(a, c);
        var f = PackageUtilities.h(b, c);
        for (var g = 0; g < e.count - 1 && g < f.count; g++) {
            if (e._inner[g] == f._inner[g]) {
                e.removeAt(g);
                f.removeAt(g);
                g--;
                continue;
            }
            else {
                if (d) {
                    var h = PackageUtilities.w.g(b, stringEmpty());
                    return stringReplace(h, c, "/");
                }
                else {
                    for (var i = 0; i < e.count - 1; i++) {
                        f.insert(0, "..");
                    }
                }
                break;
            }
        }
        var j = new StringBuilder(0);
        try {
            for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var k = _c.value;
                if (c != "/") {
                    j.l(stringReplace(k, c, "/"));
                }
                else {
                    j.l(k);
                }
                j.h("/");
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        j.y(j.c - 1, 1);
        return j.toString();
    };
    PackageUtilities.g = function (a) {
        return PackageUtilities.h(a, "/");
    };
    PackageUtilities.h = function (a, b) {
        if (stringIsNullOrEmpty(a)) {
            return new List$1(String_$type, 0);
        }
        return new List$1(String_$type, 1, a.split(b));
    };
    PackageUtilities.ak = function (a) {
        var b = PackageUtilities.ah(a.sourceUri);
        var c = PackageUtilities.ag(b, a.targetUri);
        return c;
    };
    PackageUtilities.b = function (a) {
        var b = PackageUtilities.g(a);
        if (b.count == 0) {
            return false;
        }
        if (b._inner[0].length != 0) {
            return false;
        }
        for (var c = 1; c < b.count; c++) {
            if (PackageUtilities.d(b._inner[c]) == false) {
                return false;
            }
        }
        return true;
    };
    PackageUtilities.c = function (a) {
        return PackageUtilities.b(a.toString());
    };
    PackageUtilities.d = function (a) {
        if (stringIsNullOrEmpty(a)) {
            return false;
        }
        if (a.charAt(a.length - 1) == '.') {
            return false;
        }
        var b = PackageUtilities.ae.i(a);
        if (b.i == false || b.d != a.length) {
            return false;
        }
        var c = PackageUtilities.aa.i(a);
        while (c.i) {
            var d = PackageUtilities.e(c.g);
            var e = Convert.toChar(d);
            switch (e) {
                case '\\':
                case '/': return false;
            }
            var f = e.toString();
            if (PackageUtilities.ac.i(f).i) {
                return false;
            }
            c = c.o();
        }
        return true;
    };
    PackageUtilities.i = function (a) {
        if (stringEndsWith(a, "Z") == false) {
            PackageUtilities.al("The date format was not correct.");
            return dateNow();
        }
        a = a.substr(0, a.length - 1);
        var b;
        if (!((function () { var c = DocCoreUtils.g(a, "s", null, b); b = c.p3; return c.ret; })())) {
            if (!((function () { var c = DocCoreUtils.g(a, "o", null, b); b = c.p3; return c.ret; })())) {
                PackageUtilities.al("Error occurred while parsing the date in W3CDTF format: " + a);
                return dateNow();
            }
        }
        return toLocalTime(b);
    };
    Object.defineProperty(PackageUtilities, "aa", {
        get: function () {
            if (PackageUtilities.z == null) {
                PackageUtilities.z = new Regex("%[0-9A-F]{2}", 8 | 1);
            }
            return PackageUtilities.z;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PackageUtilities, "ac", {
        get: function () {
            if (PackageUtilities.ab == null) {
                PackageUtilities.ab = new Regex("[\\-\\._~0-9A-Z]", 8 | 1);
            }
            return PackageUtilities.ab;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PackageUtilities, "ae", {
        get: function () {
            if (PackageUtilities.ad == null) {
                PackageUtilities.ad = new Regex("([:@\\-\\._~!$&'()*+,;=0-9A-Z]|(%[0-9A-F]{2}))*", 8 | 1);
            }
            return PackageUtilities.ad;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PackageUtilities, "y", {
        get: function () {
            if (PackageUtilities.x == null) {
                PackageUtilities.x = new Regex("[^.]", 8 | 1);
            }
            return PackageUtilities.x;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PackageUtilities, "w", {
        get: function () {
            if (PackageUtilities.v == null) {
                PackageUtilities.v = new Regex("\\w:", 8);
            }
            return PackageUtilities.v;
        },
        enumerable: false,
        configurable: true
    });
    PackageUtilities.al = function (a) {
        if (DocCoreUtils.f) {
            return;
        }
    };
    PackageUtilities.$t = markType(PackageUtilities, 'PackageUtilities');
    PackageUtilities.z = null;
    PackageUtilities.ab = null;
    PackageUtilities.ad = null;
    PackageUtilities.x = null;
    PackageUtilities.v = null;
    return PackageUtilities;
}(Base));
export { PackageUtilities };
