/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { UltraCalcFunctionCombin } from "./UltraCalcFunctionCombin";
import { markType } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionCombina = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionCombina, _super);
    function UltraCalcFunctionCombina() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionCombina.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c._toDecimal2();
        c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var e = c._toDecimal2();
        var f = truncate(d);
        var g = truncate(e);
        if (e < 0 || d < 0 || (g == 0 && f > 0)) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var h = UltraCalcFunctionCombin._am(g, f, true);
        if (isNaN_(h)) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        return new ExcelCalcValue(h);
    };
    UltraCalcFunctionCombina.prototype.get_name = function () {
        return "combina";
    };
    Object.defineProperty(UltraCalcFunctionCombina.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionCombina.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionCombina.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionCombina.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionCombina.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionCombina.$t = markType(UltraCalcFunctionCombina, 'UltraCalcFunctionCombina', BuiltInFunctionBase.$);
    return UltraCalcFunctionCombina;
}(BuiltInFunctionBase));
export { UltraCalcFunctionCombina };
