/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionExponDist = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionExponDist, _super);
    function UltraCalcFunctionExponDist() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionExponDist.prototype.evaluate = function (a, b) {
        var c = a.pop();
        var d = a.pop();
        var e = a.pop();
        if (e.isError) {
            return new ExcelCalcValue(e.toErrorValue());
        }
        if (d.isError) {
            return new ExcelCalcValue(d.toErrorValue());
        }
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var f = e._toDouble3();
        var g = d._toDouble3();
        var h = c._toBoolean1();
        if (f < 0 || g <= 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var i = Math.exp(-f * g);
        var j = h ? 1 - i : g * i;
        return new ExcelCalcValue(j);
    };
    UltraCalcFunctionExponDist.prototype.get_name = function () {
        return "expondist";
    };
    Object.defineProperty(UltraCalcFunctionExponDist.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionExponDist.prototype.get_minArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionExponDist.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionExponDist.prototype.get_maxArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionExponDist.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionExponDist.$t = markType(UltraCalcFunctionExponDist, 'UltraCalcFunctionExponDist', BuiltInFunctionBase.$);
    return UltraCalcFunctionExponDist;
}(BuiltInFunctionBase));
export { UltraCalcFunctionExponDist };
