/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { Random } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionRandBetween = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionRandBetween, _super);
    function UltraCalcFunctionRandBetween() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._ak = new Random(0);
        return _this;
    }
    UltraCalcFunctionRandBetween.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c._toInt();
        c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var e = c._toInt();
        if (d < e) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        return new ExcelCalcValue(this._ak.next2(e, d + 1));
    };
    UltraCalcFunctionRandBetween.prototype.get_name = function () {
        return "randbetween";
    };
    Object.defineProperty(UltraCalcFunctionRandBetween.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRandBetween.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionRandBetween.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRandBetween.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionRandBetween.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRandBetween.$t = markType(UltraCalcFunctionRandBetween, 'UltraCalcFunctionRandBetween', BuiltInFunctionBase.$);
    return UltraCalcFunctionRandBetween;
}(BuiltInFunctionBase));
export { UltraCalcFunctionRandBetween };
