/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { MathUtilities } from "./MathUtilities";
import { ValueFormatter } from "./ValueFormatter";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
import { stringFormat } from "igniteui-angular-core";
import { stringCreateFromChar } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionUSDollar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionUSDollar, _super);
    function UltraCalcFunctionUSDollar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionUSDollar.prototype.evaluate = function (a, b) {
        var c = null;
        if (b == 2) {
            c = a.pop();
        }
        var d = a.pop();
        if (d.isError) {
            return new ExcelCalcValue(d.toErrorValue());
        }
        if (c != null && c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var e = d._toDouble3();
        var f = c == null ? 2 : c._toInt();
        if (f < 0) {
            e = MathUtilities.g(e, f);
        }
        var g = f > 0 ? stringFormat("$#,##0.{0};($#,##0.{0})", stringCreateFromChar('0', f)) : "$#,##0;($#,##0)";
        var h = new ValueFormatter(0, d._o, g, a._w);
        var i;
        if (((function () { var j = h.v(e, null, i); i = j.p2; return j.ret; })()) == false) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        return new ExcelCalcValue(i);
    };
    UltraCalcFunctionUSDollar.prototype.get_name = function () {
        return "usdollar";
    };
    Object.defineProperty(UltraCalcFunctionUSDollar.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionUSDollar.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionUSDollar.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionUSDollar.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionUSDollar.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionUSDollar.$t = markType(UltraCalcFunctionUSDollar, 'UltraCalcFunctionUSDollar', BuiltInFunctionBase.$);
    return UltraCalcFunctionUSDollar;
}(BuiltInFunctionBase));
export { UltraCalcFunctionUSDollar };
