/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionWeibull = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionWeibull, _super);
    function UltraCalcFunctionWeibull() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionWeibull.prototype.evaluate = function (a, b) {
        var c = a.pop();
        var d = a.pop();
        var e = a.pop();
        var f = a.pop();
        if (f.isError) {
            return new ExcelCalcValue(f.toErrorValue());
        }
        if (e.isError) {
            return new ExcelCalcValue(e.toErrorValue());
        }
        if (d.isError) {
            return new ExcelCalcValue(d.toErrorValue());
        }
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var g = f._toDouble3();
        var h = e._toDouble3();
        var i = d._toDouble3();
        var j = c._toBoolean1();
        if (g < 0 || h <= 0 || i <= 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var k = Math.exp(-Math.pow(g / i, h));
        var l = j ? (1 - k) : h / Math.pow(i, h) * Math.pow(g, h - 1) * k;
        return new ExcelCalcValue(l);
    };
    UltraCalcFunctionWeibull.prototype.get_name = function () {
        return "weibull";
    };
    Object.defineProperty(UltraCalcFunctionWeibull.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionWeibull.prototype.get_minArgs = function () {
        return 4;
    };
    Object.defineProperty(UltraCalcFunctionWeibull.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionWeibull.prototype.get_maxArgs = function () {
        return 4;
    };
    Object.defineProperty(UltraCalcFunctionWeibull.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionWeibull.$t = markType(UltraCalcFunctionWeibull, 'UltraCalcFunctionWeibull', BuiltInFunctionBase.$);
    return UltraCalcFunctionWeibull;
}(BuiltInFunctionBase));
export { UltraCalcFunctionWeibull };
