/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Enumeration used to indicate which cells may be selected when the Worksheet is protected.
 * @see [[WorksheetProtection.selectionMode]]
 */
export var WorksheetProtectedSelectionMode = /*@__PURE__*/ (function (WorksheetProtectedSelectionMode) {
    /**
     * All cells including locked cells may be selected.
     */
    WorksheetProtectedSelectionMode[WorksheetProtectedSelectionMode["AllCells"] = 0] = "AllCells";
    /**
     * Only cells that are unlocked may be selected via the keyboard or mouse. Note a cell that is locked may be selected if a range selection is created between 2 unlocked cells.
     */
    WorksheetProtectedSelectionMode[WorksheetProtectedSelectionMode["UnlockedCells"] = 1] = "UnlockedCells";
    /**
     * The selection cannot be change.
     */
    WorksheetProtectedSelectionMode[WorksheetProtectedSelectionMode["NoCells"] = 2] = "NoCells";
    return WorksheetProtectedSelectionMode;
})({});
/**
 * @hidden
 */
export var WorksheetProtectedSelectionMode_$type = markEnum('WorksheetProtectedSelectionMode', 'AllCells,0|UnlockedCells,1|NoCells,2');
