/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various visibilities of a worksheet.
 * <p class="body">
 * The worksheet visibility indicates how the worksheet will be displayed in the tab bar at
 * the bottom of the workbook window in Microsoft Excel.
 * </p>
 */
export var WorksheetVisibility = /*@__PURE__*/ (function (WorksheetVisibility) {
    /**
     * The worksheet tab is present in the tab bar.
     */
    WorksheetVisibility[WorksheetVisibility["Visible"] = 0] = "Visible";
    /**
     * The worksheet tab is not present in the tab bar. The worksheet can be made visible
     * from the Unhide dialog in Microsoft Excel.
     */
    WorksheetVisibility[WorksheetVisibility["Hidden"] = 1] = "Hidden";
    /**
     * The worksheet tab is not present in the tab bar. The worksheet can only be made visible
     * again through a Visual Basic procedure in Microsoft Excel. The worksheet can not be made
     * visible through the user interface.
     */
    WorksheetVisibility[WorksheetVisibility["StrongHidden"] = 2] = "StrongHidden";
    return WorksheetVisibility;
})({});
/**
 * @hidden
 */
export var WorksheetVisibility_$type = markEnum('WorksheetVisibility', 'Visible,0|Hidden,1|StrongHidden,2');
