import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the placement of an [[Axis]],
 * as relative to the chart space.
 */
export declare enum AxisPosition {
    /**
     * The axis is positioned automatically, with the value axes
     * appearing on the left/right, and the category axes appearing
     * on the top/bottom.
     */
    Automatic = 0,
    /**
     * The axis appears alongside the bottom edge of the chart.
     */
    Bottom = 1,
    /**
     * The axis appears alongside the left edge of the chart.
     */
    Left = 2,
    /**
     * The axis appears alongside the right edge of the chart.
     */
    Right = 3,
    /**
     * The axis appears alongside the top edge of the chart.
     */
    Top = 4
}
/**
 * @hidden
 */
export declare let AxisPosition_$type: Type;
