import { Base, Type } from "igniteui-angular-core";
import { FormatConditionIcon } from "./FormatConditionIcon";
import { FormatConditionIconSet } from "./FormatConditionIconSet";
/**
 * Exposes the information necessary for drawing an icon for a specific cell.
 * @see [[CellConditionalFormat]]
 */
export declare class CellIconInfo extends Base {
    static $t: Type;
    private _e;
    private _g;
    private _a;
    private _c;
    constructor(a: FormatConditionIconSet, b: FormatConditionIcon, c: number, d: boolean);
    /**
     * The icon to be drawn (read-only).
     */
    get icon(): FormatConditionIcon;
    /**
     * The index of the icon in the icon set (read-only).
     */
    get iconIndex(): number;
    /**
     * The icon set (read-only).
     */
    get iconSet(): FormatConditionIconSet;
    /**
     * Returns whether the cell value is to be shown along with the data bar (read-only).
     */
    get showValue(): boolean;
}
