import { Type } from "igniteui-angular-core";
/**
 * Constants which identify whether a [[ColorScaleConditionalFormat]]
 * supports two or three thresholds. Used to differentiate between a 2-color and
 * 3-color scale.
 */
export declare enum ColorScaleType {
    /**
     * The color scale supports only the <see cref="ColorScaleConditionalFormat.MinimumThreshold">minimum</see>
     * and <see cref="ColorScaleConditionalFormat.MaximumThreshold">maximum</see> thresholds.
     */
    TwoColor = 0,
    /**
     * In addition to the the <see cref="ColorScaleConditionalFormat.MinimumThreshold">minimum</see>
     * and <see cref="ColorScaleConditionalFormat.MaximumThreshold">maximum</see> thresholds, the color
     * scale also supports a <see cref="ColorScaleConditionalFormat.MidpointThreshold">midpoint</see>
     * threshold.
     */
    ThreeColor = 1
}
/**
 * @hidden
 */
export declare let ColorScaleType_$type: Type;
