import { Type } from "igniteui-angular-core";
/**
 * Represents the description of the Japanese input rules.
 */
export declare enum DataValidationImeMode {
    /**
     * The ime mode is not controlled.
     */
    NoControl = 0,
    /**
     * The ime mode is on.
     */
    On = 1,
    /**
     * The ime mode is off.
     */
    Off = 2,
    /**
     * The ime mode is disabled.
     */
    Disabled = 3,
    /**
     * The ime mode is set to Hiragana.
     */
    Hiragana = 4,
    /**
     * The ime mode is set to Katakana
     */
    FullKatakana = 5,
    /**
     * The ime mode is set to half-width Katakana.
     */
    HalfKatakana = 6,
    /**
     * The ime mode is set to full-width alphanumeric.
     */
    FullAlpha = 7,
    /**
     * The ime mode is set to half-width alphanumeric.
     */
    HalfAlpha = 8,
    /**
     * The ime mode is set to full-width Hangul.
     */
    FullHangul = 9,
    /**
     * The ime mode is set to half-width Hangul.
     */
    HalfHangul = 10
}
/**
 * @hidden
 */
export declare let DataValidationImeMode_$type: Type;
