import { Type } from "igniteui-angular-core";
/**
 * Represents the diagonal borders which can be displayed in cells.
 */
export declare enum DiagonalBorders {
    /**
     * The default value for the diagonal borders.
     */
    Default = 0,
    /**
     * No diagonal borders will be displayed in the cell.
     */
    None = 1,
    /**
     * A diagonal border going from the top-left to bottom-right corner will be displayed in the cell.
     */
    DiagonalDown = 3,
    /**
     * A diagonal border going from the bottom-left to top-right corner will be displayed in the cell.
     */
    DiagonalUp = 5,
    /**
     * Both diagonal borders will be displayed in the cell.
     */
    All = 7
}
/**
 * @hidden
 */
export declare let DiagonalBorders_$type: Type;
