import { Type } from "igniteui-angular-core";
/**
 * Constants which define how blank cell values are plotted on the chart.
 */
export declare enum DisplayBlanksAs {
    /**
     * Points representing blank cell values are not plotted on the chart.
     */
    NotPlotted = 1,
    /**
     * Blank cell values are interpreted as having a value of zero.
     */
    Zero = 2,
    /**
     * The value is interpolated from adjacent values.
     */
    Interpolated = 3
}
/**
 * @hidden
 */
export declare let DisplayBlanksAs_$type: Type;
