import { Type } from "igniteui-angular-core";
/**
 * Constants which specify the direction in which an
 * <see cref="ErrorBars">error bar</see> extends.
 */
export declare enum ErrorBarDirection {
    /**
     * The error bar extends in both directions.
     */
    Both = 0,
    /**
     * The error bar extends only in the positive direction.
     */
    Plus = 1,
    /**
     * The error bar extends only in the negative direction.
     */
    Minus = 2
}
/**
 * @hidden
 */
export declare let ErrorBarDirection_$type: Type;
