import { Type } from "igniteui-angular-core";
/**
 * Constants which specify the units used to depict errors on an
 * <see cref="ErrorBars">error bar</see>.
 */
export declare enum ErrorValueType {
    /**
     * The error range is defined by a fixed numerical value.
     */
    FixedValue = 0,
    /**
     * The error range is defined by a percentage.
     */
    Percentage = 1,
    /**
     * The error range is defined by standard deviation.
     */
    StandardDeviation = 2,
    /**
     * The error range is defined by standard error.
     */
    StandardError = 3
}
/**
 * @hidden
 */
export declare let ErrorValueType_$type: Type;
