import { Type } from "igniteui-angular-core";
/**
 * Enumeration of error codes assigned to [[ExcelCalcErrorValue]].
 */
export declare enum ExcelCalcErrorCode {
    /**
     * Occurs when an invalid or disconnected reference is encountered while evaluating a formula
     */
    Reference = 0,
    /**
     * Occurs when the wrong type of argument or operand is used in a formula
     */
    Value = 1,
    /**
     * Occurs when a number is divided by zero (0)
     */
    Div = 2,
    /**
     * Occurs when @NA is entered into a formula
     */
    NA = 3,
    /**
     * Occurs with invalid numeric values in a formula or function
     */
    Num = 4,
    /**
     * Occurs when a circularity formula is used when circularities are not allowed.
     */
    Circularity = 5,
    /**
     * Occurs when there is an intersection of two references that do not contain any common cells.
     */
    Null = 6,
    /**
     * Occurs when text in a formula is not recognized.
     */
    Name1 = 7
}
/**
 * @hidden
 */
export declare let ExcelCalcErrorCode_$type: Type;
