import { Type } from "igniteui-angular-core";
/**
 * Enumeration for fill pattern styles. Default value is used in property override situations.
 */
export declare enum FillPatternStyle {
    /**
     * Obsolete. Use None instead.
     */
    Default = -1,
    /**
     * No fill pattern.
     */
    None = 0,
    /**
     * Solid fill pattern with fill pattern foreground color.
     */
    Solid = 1,
    /**
     * "50% gray" fill pattern.
     */
    Gray50percent = 2,
    /**
     * "75% gray" fill pattern.
     */
    Gray75percent = 3,
    /**
     * "25% gray" fill pattern.
     */
    Gray25percent = 4,
    /**
     * Horizontal stripe fill pattern.
     */
    HorizontalStripe = 5,
    /**
     * Vertical stripe fill pattern.
     */
    VerticalStripe = 6,
    /**
     * Reverse diagonal stripe fill pattern.
     */
    ReverseDiagonalStripe = 7,
    /**
     * Diagonal stripe fill pattern.
     */
    DiagonalStripe = 8,
    /**
     * Diagonal crosshatch fill pattern.
     */
    DiagonalCrosshatch = 9,
    /**
     * Thick diagonal crosshatch fill pattern.
     */
    ThickDiagonalCrosshatch = 10,
    /**
     * Thin horizontal stripe fill pattern.
     */
    ThinHorizontalStripe = 11,
    /**
     * Thin vertical stripe fill pattern.
     */
    ThinVerticalStripe = 12,
    /**
     * Thin reverse diagonal stripe fill pattern.
     */
    ThinReverseDiagonalStripe = 13,
    /**
     * Thin diagonal stripe fill pattern.
     */
    ThinDiagonalStripe = 14,
    /**
     * Thin horizontal crosshatch fill pattern.
     */
    ThinHorizontalCrosshatch = 15,
    /**
     * Thin diagonal crosshatch fill pattern.
     */
    ThinDiagonalCrosshatch = 16,
    /**
     * "12.5% gray" fill pattern.
     */
    Gray12percent = 17,
    /**
     * "6.25% gray" fill pattern.
     */
    Gray6percent = 18
}
/**
 * @hidden
 */
export declare let FillPatternStyle_$type: Type;
