import { Type } from "igniteui-angular-core";
/**
 * Constants which define the level of granularity for a geographic map chart.
 */
export declare enum GeographicMappingArea {
    /**
     * Only regions for which series data is available are displayed.
     */
    DataOnly = 0,
    /**
     * A postal region is displayed.
     */
    PostalCode = 1,
    /**
     * A county is displayed.
     */
    County = 2,
    /**
     * A state is displayed.
     */
    State = 3,
    /**
     * The entire country or region is displayed, with areas for which no
     * series data is available appearing in a lighter color.
     */
    CountryOrRegion = 4,
    /**
     * Multiple countries or regions are displayed, with areas for which no
     * series data is available appearing in a lighter color.
     */
    MultipleCountriesOrRegions = 5,
    /**
     * The entire world map is displayed, with areas for which no
     * series data is available appearing in a lighter color.
     */
    World = 6
}
/**
 * @hidden
 */
export declare let GeographicMappingArea_$type: Type;
