import { Type } from "igniteui-angular-core";
/**
 * Enumeration for horizontal alignment styles. Default value is used in property override situations.
 */
export declare enum HorizontalCellAlignment {
    /**
     * Use the current default.
     */
    Default = -1,
    /**
     * Alignment depends on underlying data type.
     */
    General = 0,
    /**
     * Left alignment.
     */
    Left = 1,
    /**
     * Centered alignment.
     */
    Center = 2,
    /**
     * Right alignment.
     */
    Right = 3,
    /**
     * Repeat cell value to fill whole cell.
     */
    Fill = 4,
    /**
     * Justify alignment.
     */
    Justify = 5,
    /**
     * Centers the contents of the left-most cell in a center across selection group. All other cells in the center across selection group must be empty. The cells are not merged, and the data may appear to be in a cell other than the left-most cell.
     */
    CenterAcrossSelection = 6,
    /**
     * Distributed alignment.
     */
    Distributed = 7
}
/**
 * @hidden
 */
export declare let HorizontalCellAlignment_$type: Type;
