import { Type } from "igniteui-angular-core";
/**
 * Represents the various horizontal text alignment types.
 */
export declare enum HorizontalTextAlignment {
    /**
     * Align text in the center of the line.
     */
    Center = 0,
    /**
     * Distributes the words across the entire line.
     */
    Distributed = 1,
    /**
     * Align text so it is justified across the line.
     */
    Justified = 2,
    /**
     * Aligns the text with an adjusted kashida length for Arabic text.
     */
    JustifiedLow = 3,
    /**
     * Align the text to the left of the line.
     */
    Left = 4,
    /**
     * Align the text to the right of the line.
     */
    Right = 5,
    /**
     * Distributes Thai text by treating each character as a word.
     */
    ThaiDistributed = 6
}
/**
 * @hidden
 */
export declare let HorizontalTextAlignment_$type: Type;
