import { Type } from "igniteui-angular-core";
/**
 * Determines the style of a line, i.e., solid, dashed, dotted, etc.
 * @see [[ChartLine.lineStyle]]
 */
export declare enum LineStyle {
    /**
     * Solid line.
     */
    Solid = 0,
    /**
     * Dashed line.
     */
    Dash = 1,
    /**
     * Alternating dashes and dots.
     */
    DashDot = 2,
    /**
     * Dotted line.
     */
    Dot = 3,
    /**
     * Large dashed line.
     */
    LargeDash = 4,
    /**
     * Large alternating dashes and dots.
     */
    LargeDashDot = 5,
    /**
     * Large alternating dashes and pairs of dots.
     */
    LargeDashDotDot = 6,
    /**
     * No line.
     */
    None = 7,
    /**
     * System-defined dashed line.
     */
    SysDash = 8,
    /**
     * System-defined alternating dashes and dots.
     */
    SysDashDot = 9,
    /**
     * System-defined alternating dashes and pairs of dots.
     */
    SysDashDotDot = 10,
    /**
     * System-defined dotted line.
     */
    SysDot = 11
}
/**
 * @hidden
 */
export declare let LineStyle_$type: Type;
