import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the style of the markers displayed by line charts.
 */
export declare enum MarkerStyle {
    /**
     * The marker style is determined automatically.
     */
    Automatic = -4105,
    /**
     * The marker is circular.
     */
    Circle = 8,
    /**
     * The marker is a dash.
     */
    Dash = -4115,
    /**
     * The marker is diamond-shaped.
     */
    Diamond = 2,
    /**
     * The marker is a dot or bullet.
     */
    Dot = -4118,
    /**
     * No marker is displayed.
     */
    None = -4142,
    /**
     * The marker appears as a picture.
     */
    Picture = -4147,
    /**
     * The marker appears as a plus sign (+).
     */
    Plus = 9,
    /**
     * The marker appears as a square.
     */
    Square = 1,
    /**
     * The marker appears as a star.
     */
    Star = 5,
    /**
     * The marker appears as a triangle.
     */
    Triangle = 3,
    /**
     * The marker appears as an 'X'
     */
    X = -4168
}
/**
 * @hidden
 */
export declare let MarkerStyle_$type: Type;
