import { Type } from "igniteui-angular-core";
/**
 * Represents the way pages are numbered when printed.
 */
export declare enum PageNumbering {
    /**
     * Pages are automatically numbered based on the style of the worksheet.
     */
    Automatic = 0,
    /**
     * The starting page number specified is used for the first page, additional
     * pages receive a page number that it one greater than the previous page.
     */
    UseStartPageNumber = 1
}
/**
 * @hidden
 */
export declare let PageNumbering_$type: Type;
