import { Type } from "igniteui-angular-core";
/**
 * Represents the shape types that are predefined in Microsoft Excel.
 */
export declare enum PredefinedShapeType {
    /**
     * Represents the [[DiamondShape]] shape.
     */
    Diamond = 4,
    /**
     * Represents the [[EllipseShape]] shape.
     */
    Ellipse = 3,
    /**
     * Represents the [[HeartShape]] shape.
     */
    Heart = 74,
    /**
     * Represents the [[IrregularSeal1Shape]] shape.
     */
    IrregularSeal1 = 71,
    /**
     * Represents the [[IrregularSeal2Shape]] shape.
     */
    IrregularSeal2 = 72,
    /**
     * Represents the [[LightningBoltShape]] shape.
     */
    LightningBolt = 73,
    /**
     * Represents the [[LineShape]] shape.
     */
    Line = 20,
    /**
     * Represents the [[PentagonShape]] shape.
     */
    Pentagon = 56,
    /**
     * Represents the [[RectangleShape]] shape.
     */
    Rectangle = 1,
    /**
     * Represents the [[RightTriangleShape]] shape.
     */
    RightTriangle = 6,
    /**
     * Represents the [[StraightConnector1Shape]] shape.
     */
    StraightConnector1 = 32
}
/**
 * @hidden
 */
export declare let PredefinedShapeType_$type: Type;
