import { Type } from "igniteui-angular-core";
/**
 * Represents the various ways to print cell notes.
 */
export declare enum PrintNotes {
    /**
     * Cell notes are not printed.
     */
    DontPrint = 0,
    /**
     * Cell notes are printed as they are shown on the worksheet. With this option, cell
     * notes will only appear in the printed worksheet if they are displayed on the worksheet
     * in Microsoft Excel. If the notes just show indicators in Excel, the indicators and notes
     * will not be printed.
     */
    PrintAsDisplayed = 1,
    /**
     * Cell notes are printed on the last page, after the entire worksheet has printed.
     */
    PrintAtEndOfSheet = 2
}
/**
 * @hidden
 */
export declare let PrintNotes_$type: Type;
