import { Type } from "igniteui-angular-core";
/**
 * Represents the various durations which can be filtered by the [[RelativeDateRangeFilter]].
 * @see [[RelativeDateRangeFilter.duration]]
 */
export declare enum RelativeDateRangeDuration {
    /**
     * The duration of accepted values is one day.
     */
    Day = 0,
    /**
     * The duration of accepted values is one week.
     */
    Week = 1,
    /**
     * The duration of accepted values is one month.
     */
    Month = 2,
    /**
     * The duration of accepted values is one quarter.
     */
    Quarter = 3,
    /**
     * The duration of accepted values is one year.
     */
    Year = 4
}
/**
 * @hidden
 */
export declare let RelativeDateRangeDuration_$type: Type;
