import { Type } from "igniteui-angular-core";
/**
 * Represents the various relative date offsets which can be filtered by the [[RelativeDateRangeFilter]].
 * @see [[RelativeDateRangeFilter.offset]]
 */
export declare enum RelativeDateRangeOffset {
    /**
     * Filter in values in the previous duration relative to the filter's creation date.
     */
    Previous = 0,
    /**
     * Filter in values in the current duration relative to the filter's creation date.
     */
    Current = 1,
    /**
     * Filter in values in the next duration relative to the filter's creation date.
     */
    Next = 2
}
/**
 * @hidden
 */
export declare let RelativeDateRangeOffset_$type: Type;
