import { Type } from "igniteui-angular-core";
/**
 * Represents the various scroll bar configurations available for the workbook.
 */
export declare enum ScrollBars {
    /**
     * No scroll bars are shown in Microsoft Excel.
     */
    None = 0,
    /**
     * Only the horizontal scroll bar is shown in Microsoft Excel.
     */
    Horizontal = 1,
    /**
     * Only the vertical scroll bar is shown in Microsoft Excel.
     */
    Vertical = 2,
    /**
     * Both scroll bars are shown in Microsoft Excel.
     */
    Both = 3
}
/**
 * @hidden
 */
export declare let ScrollBars_$type: Type;
