import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the manner in which series values
 * are used to color regions on a geographic map chart.
 * <p class="body">
 * Applicable only when the associated series [[Series.chartType]] is <i>RegionMap</i>.
 * </p>
 */
export declare enum SeriesValuesColorBy {
    /**
     * The coloring of map regions is determined by the numerical value of the associated data point.
     */
    NumericalValue = 0,
    /**
     * The coloring of map regions is determined by the value of the associated data point,
     * which is assumed to represent a category.
     */
    SecondaryCategory = 1
}
/**
 * @hidden
 */
export declare let SeriesValuesColorBy_$type: Type;
