import { Type } from "igniteui-angular-core";
/**
 * Determines how the min or max axis is calculated for a
 * @see [[Sparkline]]
 * @see [[SparklineGroup.verticalAxisMaxType]]
 * @see [[SparklineGroup.verticalAxisMinType]]
 */
export declare enum SparklineAxisMinMax {
    /**
     * Specifies that the vertical axis minimum or maximum for each sparkline in this sparkline group is calculated automatically such that the data point with the minimum or maximum value can be displayed in the plot area.
     */
    Individual = 0,
    /**
     * Specifies that the vertical axis minimum or maximum is shared across all sparklines in this sparkline group and is calculated automatically such that the data point with the minimum or maximum value can be displayed in the plot area.
     */
    Group = 1,
    /**
     * Specifies that the vertical axis minimum or maximum for each sparkline in this sparkline group is specified by the [[SparklineGroup.verticalAxisMin]] or the [[SparklineGroup.verticalAxisMax]] attribute of the [[SparklineGroup]].
     */
    Custom = 2
}
/**
 * @hidden
 */
export declare let SparklineAxisMinMax_$type: Type;
