import { Type } from "igniteui-angular-core";
/**
 * Constants which determine  the manner in which cell values
 * are compared to the [[ConditionValue.value]]
 * property when conditional criteria is evaluated by an
 * [[IconSetConditionalFormat]].
 */
export declare enum ThresholdComparison {
    /**
     * The cell value can be greater than <b>or equal to</b> the threshold <see cref="ConditionValue.Value">value</see>.
     */
    GreaterEqual = 0,
    /**
     * The cell value must be greater than <b>but not equal to</b> the threshold <see cref="ConditionValue.Value">value</see>.
     */
    Greater = 1
}
/**
 * @hidden
 */
export declare let ThresholdComparison_$type: Type;
