import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the placement of an axis' <see cref="Axis.TickLabels">tick labels</see>.
 */
export declare enum TickLabelPosition {
    /**
     * Tick labels appear near the highest data value.
     */
    High = -4127,
    /**
     * Tick labels appear near the lowest data value.
     */
    Low = -4134,
    /**
     * Tick labels appear near the axis.
     */
    NextToAxis = 4,
    /**
     * Tick labels are not displayed.
     */
    None = -4142
}
/**
 * @hidden
 */
export declare let TickLabelPosition_$type: Type;
