import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the type of a [[Wall]],
 * i.e., back, side, or floor. Applicable only for 3-D charts.
 */
export declare enum WallType {
    /**
     * The back wall, i.e., "behind" the plot area.
     */
    Back = 0,
    /**
     * The side wall. Note that only one side is ever visible,
     * based on the rotation around the Y-axis.
     */
    Side = 1,
    /**
     * The bottom wall, i.e., the floor of the chart.
     */
    Floor = 2,
    /**
     * Applies to the back and side walls, and the floor.
     */
    All = 3
}
/**
 * @hidden
 */
export declare let WallType_$type: Type;
