import { Type } from "igniteui-angular-core";
/**
 * Represents the various areas which can have a format applied at the table column level.
 * @see [[WorksheetTableColumn.areaFormats]]
 */
export declare enum WorksheetTableColumnArea {
    /**
     * The format is applied to the data area of the table column.
     */
    DataArea = 0,
    /**
     * The format is applied to the header cell of the table column.
     */
    HeaderCell = 1,
    /**
     * The format is applied to the total cell of the table column.
     */
    TotalCell = 2
}
/**
 * @hidden
 */
export declare let WorksheetTableColumnArea_$type: Type;
