import { Type } from "igniteui-angular-core";
/**
 * Represents the various visibilities of a worksheet.
 * <p class="body">
 * The worksheet visibility indicates how the worksheet will be displayed in the tab bar at
 * the bottom of the workbook window in Microsoft Excel.
 * </p>
 */
export declare enum WorksheetVisibility {
    /**
     * The worksheet tab is present in the tab bar.
     */
    Visible = 0,
    /**
     * The worksheet tab is not present in the tab bar. The worksheet can be made visible
     * from the Unhide dialog in Microsoft Excel.
     */
    Hidden = 1,
    /**
     * The worksheet tab is not present in the tab bar. The worksheet can only be made visible
     * again through a Visual Basic procedure in Microsoft Excel. The worksheet can not be made
     * visible through the user interface.
     */
    StrongHidden = 2
}
/**
 * @hidden
 */
export declare let WorksheetVisibility_$type: Type;
